#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import tkinter as tk
from tkinter import *
from tkinter import filedialog
import json, time, datetime, sys


root = Tk()
root.title("   JSON3 TO SRT - Clipboard   ")
root.geometry("1024x700")
root.configure(bg="#FFFFFA")


def parseJson():

    if srt_text.get() == "":

        file_name = "subtitle"

    else:
    
        file_name = srt_text.get()
    

    json_file = open(file_name + ".json", "w")
    
    json_file.write(json_text.get(1.0, 'end'))
 
    srt_file = open(file_name + ".srt", "w")

    
    with open((file_name + ".json"), "r") as f:

        data = json.load(f)

        line = 1

        for subs in data['events']:

            time_start = datetime.datetime.utcfromtimestamp(subs['tStartMs']/1000).strftime('%H:%M:%S,%f')[:12] 
    
            time_end = datetime.datetime.utcfromtimestamp((subs['tStartMs']/1000 + subs['dDurationMs']/1000)).strftime('%H:%M:%S,%f')[:12]

            sub = subs['segs'][0]['utf8']
            
            timestamp = ("%i\n" "%s --> %s\n" "%s\n\n") % (line, time_start, time_end, sub)

            line = line + 1 
            
            srt_file.write(timestamp)

        srt_file.close()


        ## message new window
        
        new_window = Toplevel(root, bg="#FFFFFA")
        
        message = ("%s" "%s") % (file_name + ".json\n\n", file_name + ".srt")
        
        console = ("\nThe following files have been created: ", message)

        
        for text in console:
            
            labl3 = Label(new_window, text=text, bg="#FFFFF0", fg="blue", font="bold")

            labl3.pack(padx=20, pady=10)



def cancel():

    exit()


def cleanJsonText():

    json_text.delete(0.0, 'end')


def cleanSrtName():
    
    srt_text.delete(0, 'end')


##Widgets

labl = Label(root, text="   Convert JSON3 file to SRT format   ", font="bold", fg="#FFFFFA", bg="#555555")
labl.place(relx=0.36, rely=0.02, relheight=0.03)

labl1 = Label(root, text="Enter file name .srt (without extension)", fg="blue", bg="#FFFFFA")
labl1.place(relx=0.02, rely=0.08)

srt_text = Entry(root)
srt_text.place(relx=0.32, rely=0.08, relwidth=0.30)

clean_entry = Button(root, text="Clean", command=cleanSrtName)
clean_entry.place(relx=0.64, rely=0.08, relheight=0.03)

labl2 = Label(root, text="Copy/Paste file .json", fg="blue", bg="#FFFFFA")
labl2.place(relx=0.02, rely=0.15)

json_text = Text(root)
json_text.place(relx=0.02, rely=0.20, relwidth=0.96, relheight=0.70)

parser = Button(root, text="Convert", command=parseJson)
parser.place(relx=0.40, rely=0.92)

clean_text = Button(root, text="Clean field", command=cleanJsonText)
clean_text.place(relx=0.50, rely=0.92)

button_exit = Button(root, text="Finalize", command=cancel)
button_exit.place(relx=0.65, rely=0.92)


root.mainloop()

