#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import json, time, datetime, sys
import os
import tkinter as tk
from tkinter import *
from tkinter import filedialog


root = Tk()
root.title("  JSON3 TO SRT - GUI  ")
root.geometry("640x480")
root.configure(bg="#FFFFFA")


def parseJson():

    json_file = filedialog.askopenfilename(initialdir="/", title="Select File",
            filetypes=(("json files", "*.json"),("all files","*.*")))  
    

    if srt_text.get() == "":

        file_name = "subtitle"
        
        srt_file = open(file_name + ".srt", "w")

        message = ("%s" "%s") % (json_file + " --> ", file_name + ".srt")

        
    else:

        srt_file = open(srt_text.get() + ".srt", "w")

        message = ("%s" "%s") % (json_file + " --> ", srt_text.get() + ".srt")
        

    with open(json_file, "r") as f:   
    
        data = json.load(f)
      
        line = 1

        for subs in data['events']:

            time_start = datetime.datetime.utcfromtimestamp(subs['tStartMs']/1000).strftime('%H:%M:%S,%f')[:12] 
    
            time_end = datetime.datetime.utcfromtimestamp((subs['tStartMs']/1000 + subs['dDurationMs']/1000)).strftime('%H:%M:%S,%f')[:12]

            sub = subs['segs'][0]['utf8']
            
            timestamp = ("%i\n" "%s --> %s\n" "%s\n\n") % (line, time_start, time_end, sub)

            line = line + 1 
            
            srt_file.write(timestamp)

        srt_file.close()

                        
        console = ("\nConverted:", message)


        ## reset message in console
        
        for widget in frame.winfo_children():

                widget.destroy()

        
        for text in console:
            
            labl2 = Label(frame, text=text, font="bold", bg="#FFFFDA")

            labl2.pack(pady=5)

##            srt_text.delete(0, END)
               
def clean():

    srt_text.delete(0, END)


def cancel():

    exit()


labl = Label(root, text="   Convert JSON3 file to SRT format   ", font="bold", bg="#555555", fg="#FFFFFA")
labl.place(x=170, y=20)

labl1 = Label(root, text=" Enter file name .srt (without extension) ", bg="#FFFFFA")
labl1.place(x= 175, y=100)

srt_text = Entry(root, bg="#ffffff")
srt_text.place(x=185, y=135, height=30)


btn_dialog_clean = Button(root, text=" Clean ", bg="#FFFFFA", command=clean)
btn_dialog_clean.place(x=360, y=135)


btn_dialog_parse = Button(root, text=" Select file .json and Convert ", bg="#FFFFFA", command=parseJson)
btn_dialog_parse.place(x=200, y=200)


btn_dialog_cancel = Button(root, text=" Exit ", bg="#FFFFFA", command=cancel)
btn_dialog_cancel.place(x=285, y=280)


frame = Frame(root, bg="#FFFFDA")
frame.place(rely=0.78, relwidth=1, relheight=0.20)


root.mainloop()
    

    
    
