#!/usr/bin/env python3
# -*- coding: utf-8 -*-

import json, time, datetime, sys

print("+--------------------------------------------------------------------+")
print("|                 Convert JSON3 file to SRT format                   |")
print("|                                                                    |")
print("| If the .json file is in another folder, specify the absolute path: |")
print("| Example: /home/user/bar/foo.json or, ../../foo.json                |")
print("|                                                                    |")
print("|                     Press Ctrl + c to Cancel                       |")
print("+--------------------------------------------------------------------+\n")


def parseJson():
    
    json_file = input("\nFile .json --> ")

    srt_file = input("\nFile name .srt (without extension) --> ")

    if srt_file == "":
        
        file_name = "subtitle"

        file = open(file_name + ".srt", "w")

        message = ("%s" "%s") % (json_file + " --> ", file_name + ".srt")
        
    else:

        file = open(srt_file + ".srt", "w")

        message = ("%s" "%s") % (json_file + " --> ", srt_file + ".srt")
    

    with open(json_file, "r") as f:
    
        data = json.load(f)

        line = 1
            
        for subs in data['events']:
    
            time_start = datetime.datetime.utcfromtimestamp(subs['tStartMs']/1000).strftime('%H:%M:%S,%f')[:12] 
    
            time_end = datetime.datetime.utcfromtimestamp((subs['tStartMs']/1000 + subs['dDurationMs']/1000)).strftime('%H:%M:%S,%f')[:12]

            sub = subs['segs'][0]['utf8']
            
            timestamp = ("%i\n" "%s --> %s\n" "%s\n\n") % (line, time_start, time_end, sub)

            line = line + 1

            file.write(timestamp)
                        
        file.close()
    
        print("\nConverted", message)    
    

    def  question():
    
        questions = input("\nYou want to convert another .json file [y/n]: ") 

        if questions == "y":

            parseJson()

        elif questions == "n":

            print("\nFinalized\n")
            
            exit()

        else:

            print("\nPlease enter 'y' or 'n' ")

            question()        

    question()

parseJson()
